package main

import (
	"flag"
	"fmt"
)

var (
	testURL        = flag.String("url", "http://192.168.175.60:8088", "login url")
	testProductKey = flag.String("productkey", "99b11b395c84435202692e36dada175c7af9452038a62a40b230b5e18b7d51ff", "product key")
	testProtocol   = flag.String("protocol", "mqtt", "access protocol")
)

func main() {
	flag.Parse()

	if *testProductKey == "" {
		fmt.Println("product key not provided. use -productkey flag")
		return
	}

	dev := NewDevice(*testURL, *testProductKey, "ffe34e", "version", *testProtocol)

	err := dev.DoRegister()
	if err != nil {
		fmt.Printf("device register error %s", err)
		return
	}

	err = dev.DoLogin()
	if err != nil {
		fmt.Printf("device login error %s", err)
		return
	}

	err = dev.DoAccess()
	if err != nil {
		fmt.Printf("device access error %s", err)
		return
	}

}
